Bug 1066353 (CVE-2013-4529)

Summary: CVE-2013-4529 qemu: hw/pci/pcie_aer.c: buffer overrun on invalid state load
Product: [Other] Security Response Reporter: Petr Matousek <pmatouse>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: abaron, amit.shah, aortega, apevec, areis, ayoung, berrange, bsarathy, cfergeau, chrisw, dallan, dwmw2, ehabkost, gkotton, gleb, gmollett, itamar, jkurik, jrusnack, juzhang, knoel, lhh, lpeer, markmc, minovotn, mkenneth, mst, mtosatti, pbonzini, pfrields, ppandit, rbalakri, rbryant, rhod, rjones, sclewis, scottt.tw, virt-maint, virt-maint, yeylon
Target Milestone: ---Keywords: Reopened, Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-09-22 04:53:24 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1095713, 1095714, 1095716, 1133850    
Bug Blocks: 1036654, 1133827    

Description Petr Matousek 2014-02-18 09:37:47 UTC
Michael S. Tsirkin writes:

There are two issues in hw/pci/pcie_aer.c:
1. log_max from remote can be larger than on local then buffer will
   overrun with data coming from state file.
2. log_num can be larger then we get data corrution again with an
   overflow but not adversary controlled.

An user able to alter the savevm data (either on the disk or over the wire
during migration) could use this flaw to to corrupt QEMU process memory on
the (destination) host, which could potentially result in arbitrary code
execution on the host with the privileges of the QEMU process.

Upstream fix:
-------------
  -> http://git.qemu.org/?p=qemu.git;a=commit;h=5f691ff91d323b6f97c6600405a7f9dc115a0ad1

Comment 1 Petr Matousek 2014-02-18 11:16:22 UTC
Statement:

This issue does not affect the versions of kvm package as shipped with
Red Hat Enterprise Linux 5.

This issue does not affect the versions of qemu-kvm package as shipped
with Red Hat Enterprise Linux 6.

Comment 3 Prasad J Pandit 2014-05-08 12:27:07 UTC
Created qemu tracking bugs for this issue:

Affects: fedora-all [bug 1095713]

Comment 4 Fedora Update System 2014-05-16 10:00:18 UTC
qemu-1.6.2-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 5 Prasad J Pandit 2014-07-18 13:33:23 UTC
Acknowledgements:

The issues were discovered as part of the state loading code audit performed by Michael S. Tsirkin of Red Hat, Anthony Liguori and Michael Roth.

Comment 6 errata-xmlrpc 2014-07-23 16:15:52 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 7

Via RHSA-2014:0927 https://rhn.redhat.com/errata/RHSA-2014-0927.html

Comment 9 errata-xmlrpc 2014-09-22 04:01:22 UTC
This issue has been addressed in the following products:

  OpenStack 5 for RHEL 7

Via RHSA-2014:1268 https://rhn.redhat.com/errata/RHSA-2014-1268.html